<template>
    <dialog ref="dialog" class="the-editor-dialog" @close="close">
        <div class="the-editor-dialog-wrapper">
            <form ref="form" v-if="visible" method="dialog">
                <slot></slot>
            </form>
            <button class="the-editor-dialog-close" title="close popup" aria-label="close" @click="close">
                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-x-lg"
                    viewBox="0 0 16 16">
                    <path
                        d="M2.146 2.854a.5.5 0 1 1 .708-.708L8 7.293l5.146-5.147a.5.5 0 0 1 .708.708L8.707 8l5.147 5.146a.5.5 0 0 1-.708.708L8 8.707l-5.146 5.147a.5.5 0 0 1-.708-.708L7.293 8z" />
                </svg>
            </button>
        </div>
    </dialog>
</template>

<script setup lang="ts">
import { ref } from 'vue'
const visible = ref(false)
const dialog = ref<HTMLDialogElement>()
const form = ref<HTMLFormElement>()
const clickDetect = (e: MouseEvent) => {
    let rect = dialog.value!.getBoundingClientRect();
    let isInDialog = (rect.top <= e.clientY && e.clientY <= rect.top + rect.height &&
        rect.left <= e.clientX && e.clientX <= rect.left + rect.width);
    if (!isInDialog) {
        close()
    }
}
const open = () => {
    visible.value = true
    dialog.value?.showModal()
    dialog.value?.addEventListener('click', clickDetect)
    form.value?.focus()
}
const close = () => {
    visible.value = false
    dialog.value?.close()
    dialog.value?.removeEventListener('click', clickDetect)
}

defineEmits<{
    (e: 'confirm', data: any): void,
}>()

defineExpose({
    open,
    close,
})
</script>

<style scoped>
.the-editor-dialog::backdrop {
    background-color: rgba(0, 0, 0, 0.4);
}

.the-editor-dialog {
    border: 0;
    width: 600px;
    max-width: 80vw;
    border-radius: 8px;
    padding: 0rem;
}

.the-editor-dialog-wrapper {
    padding: 1rem;
    position: relative;
    padding-top: 2rem;
}

.the-editor-dialog-close {
    all: unset;
    position: absolute;
    text-align: center;
    top: 1px;
    right: 1px;
    padding: 0rem;
    cursor: pointer;
    border-radius: 50%;
    line-height: 0;
}
.the-editor-dialog-close:focus{
    outline: 2px solid #000000;
}
</style>